// Copyright 2009 and onwards
// Author: dtarlow@cs.toronto.edu (Danny Tarlow)
// 7/27/09

#ifndef CYBORG_SINGLETON_FACTOR_H__
#define CYBORG_SINGLETON_FACTOR_H__

#include "factor.h"
#include <vector>
#include <string>


class SingletonFactor : public Factor{
 public:
  SingletonFactor(string name);
  ~SingletonFactor();
  
  double Potential() { return on_potential_; }

  void SetPotential(double potential);

  void ComputeOutgoingMessage(int position_in_facator);

  void ComputeAllOutgoingMessages();

  double Likelihood();

  /*
  void UpdateOutgoingMessage(int position_in_factor);
  void UpdateAllOutgoingMessages();
  */

  void Touch();  

 private:
  double on_potential_;

};

#endif
