// Copyright 2009 and onwards
// Author: dtarlow@cs.toronto.edu (Danny Tarlow)
// 8/2/09

#ifndef CYBORG_POTTS_FACTOR_H__
#define CYBORG_POTTS_FACTOR_H__

#include "factor.h"
#include <vector>
#include <string>


class PottsFactor : public Factor{
 public:
  PottsFactor(string name);
  ~PottsFactor();
  
  double Potential() { return both_on_potential_; }

  void SetPotential(double potential);

  void ComputeOutgoingMessage(int position_in_factor);  

  void ComputeAllOutgoingMessages();

  void Print() {
    cout << Name() << " (" << both_on_potential_ << ")";
  }

  double Likelihood();

 private:
  double both_on_potential_;
  

};

#endif
